/*
 *    Copyright 2014-2023 IHE International
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

/**
 * AuditedEvent.java
 * <p>
 * File generated from the ATNAQuestionnaire::AuditedEvent uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.atna.questionnaire.model;

// End of user code

import net.ihe.gazelle.tf.ws.data.AuditMessageWrapper;
import org.hibernate.annotations.Type;
import org.w3c.dom.Node;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import java.io.File;
import java.util.Date;

/**
 * Description of the class AuditedEvent.
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "AuditedEvent", propOrder = {"fileLocation", "comment", "auditedTransaction", "issuingActor",
        "name", "validationStatus", "validatorOid", "validationLogPath"})
@XmlRootElement(name = "AuditedEvent")
@Entity
@Table(name = "atna_audited_event", schema = "public")
@SequenceGenerator(name = "atna_audited_event_sequence", sequenceName = "atna_audited_event_id_seq", allocationSize = 1)
public class AuditedEvent implements java.io.Serializable, SystemRegistrationComparable {

    /**
     *
     */
    private static final long serialVersionUID = 1L;

    @Id
    @Column(name = "id", unique = true, nullable = false)
    @GeneratedValue(generator = "atna_audited_event_sequence", strategy = GenerationType.SEQUENCE)
    private Integer id;

    @XmlElement(name = "fileLocation", required = false)
    @Column(name = "file_location")
    private String fileLocation;

    @XmlElement(name = "Comment")
    @Lob
    @Type(type = "text")
    private String comment;

    @XmlAttribute(name = "auditedTransaction", required = true)
    @Column(name = "audited_transaction")
    private String auditedTransaction;

    @XmlAttribute(name = "issuingActor", required = true)
    @Column(name = "issuing_actor")
    private String issuingActor;

    @XmlAttribute(name = "name", required = true)
    private String name;

    /**
     * validation status retrieve from EVSClient or given by the monitor if there is no validator defined for this event.
     */
    @XmlAttribute(name = "validationStatus")
    @Column(name = "validation_status")
    private ValidationStatus validationStatus;

    @XmlTransient
    @Column(name = "validation_log_path")
    private String validationLogPath;

    @XmlTransient
    @Column(name = "validation_date")
    @Temporal(TemporalType.TIMESTAMP)
    private Date validationDate;

    /**
     * OID of the validator to use.
     */
    @XmlAttribute(name = "validatorOid")
    @Column(name = "validator_oid")
    private String validatorOid;

    @XmlTransient
    @ManyToOne(cascade = {CascadeType.MERGE, CascadeType.PERSIST})
    @JoinColumn(name = "atna_questionnaire_id")
    private ATNAQuestionnaireType atnaQuestionnaire;

    @Column(name = "produced_by_system")
    private BooleanAnswer producedBySystem;
    /**
     * An attribute containing marshalled element node
     */
    @XmlTransient
    @Transient
    private org.w3c.dom.Node xmlNodePresentation;

    public AuditedEvent() {
        super();
    }

    public AuditedEvent(AuditMessageWrapper wrapper) {
        if (wrapper != null) {
            this.auditedTransaction = wrapper.getAuditedTransaction().getKeyword() + " - " + wrapper.getAuditedTransaction().getName();
            this.issuingActor = wrapper.getIssuingActor().getName();
            this.name = wrapper.getAuditedEvent();
            this.validatorOid = wrapper.getOid();
            this.atnaQuestionnaire = null;
            this.producedBySystem = BooleanAnswer.NC;
            this.validationStatus = ValidationStatus.NOFILE;
        }
    }

    /**
     * Return comment.
     *
     * @return comment
     */
    public String getComment() {
        return comment;
    }

    /**
     * Set a value to attribute comment.
     *
     * @param comment .
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    /**
     * Return auditedTransaction.
     *
     * @return auditedTransaction
     */
    public String getAuditedTransaction() {
        return auditedTransaction;
    }

    /**
     * Set a value to attribute auditedTransaction.
     *
     * @param auditedTransaction .
     */
    public void setAuditedTransaction(String auditedTransaction) {
        this.auditedTransaction = auditedTransaction;
    }

    /**
     * Return issuingActor.
     *
     * @return issuingActor
     */
    public String getIssuingActor() {
        return issuingActor;
    }

    /**
     * Set a value to attribute issuingActor.
     *
     * @param issuingActor .
     */
    public void setIssuingActor(String issuingActor) {
        this.issuingActor = issuingActor;
    }

    /**
     * Return name.
     *
     * @return name
     */
    public String getName() {
        return name;
    }

    /**
     * Set a value to attribute name.
     *
     * @param name .
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Return validationStatus.
     *
     * @return validationStatus : validation status retrieve from EVSClient or given by the monitor if there is no validator defined for this
     * eventvalidation status retrieve from EVSClient or given by
     * the monitor if there is no validator defined for this event
     */
    public ValidationStatus getValidationStatus() {
        return validationStatus;
    }

    /**
     * Set a value to attribute validationStatus.
     *
     * @param validationStatus : validation status retrieve from EVSClient or given by the monitor if there is no validator defined for this
     *                         eventvalidation
     *                         status retrieve from EVSClient or given by the monitor
     *                         if there is no validator defined for this event.
     */
    public void setValidationStatus(ValidationStatus validationStatus) {
        this.validationStatus = validationStatus;
    }

    /**
     * Return validatorOid.
     *
     * @return validatorOid : OID of the validator to useOID of the validator to use
     */
    public String getValidatorOid() {
        return validatorOid;
    }

    /**
     * Set a value to attribute validatorOid.
     *
     * @param validatorOid : OID of the validator to useOID of the validator to use.
     */
    public void setValidatorOid(String validatorOid) {
        this.validatorOid = validatorOid;
    }

    public Node getXmlNodePresentation() {
        if (xmlNodePresentation == null) {
            xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "AuditedEvent", this);
        }
        return xmlNodePresentation;
    }

    public void setXmlNodePresentation(Node xmlNodePresentation) {
        this.xmlNodePresentation = xmlNodePresentation;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public ATNAQuestionnaireType getAtnaQuestionnaire() {
        return atnaQuestionnaire;
    }

    void setAtnaQuestionnaire(ATNAQuestionnaireType atnaQuestionnaire) {
        this.atnaQuestionnaire = atnaQuestionnaire;
    }

    public BooleanAnswer getProducedBySystem() {
        return producedBySystem;
    }

    public void setProducedBySystem(BooleanAnswer producedBySystem) {
        this.producedBySystem = producedBySystem;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }

        AuditedEvent that = (AuditedEvent) o;

        if (getComment() != null ? !getComment().equals(that.getComment()) : that.getComment() != null) {
            return false;
        }
        if (getAuditedTransaction() != null ? !getAuditedTransaction().equals(that.getAuditedTransaction()) : that.getAuditedTransaction() != null) {
            return false;
        }
        if (getIssuingActor() != null ? !getIssuingActor().equals(that.getIssuingActor()) : that.getIssuingActor() != null) {
            return false;
        }
        if (getName() != null ? !getName().equals(that.getName()) : that.getName() != null) {
            return false;
        }
        if (getValidationDate() != null ? !getValidationDate().equals(that.getValidationDate()) : that.getValidationDate() != null) {
            return false;
        }
        if (getValidatorOid() != null ? !getValidatorOid().equals(that.getValidatorOid()) : that.getValidatorOid() != null) {
            return false;
        }
        if (getAtnaQuestionnaire() != null ? !getAtnaQuestionnaire().equals(that.getAtnaQuestionnaire()) : that.getAtnaQuestionnaire() != null) {
            return false;
        }
        if (getProducedBySystem() != that.getProducedBySystem()) {
            return false;
        }

        return true;
    }

    @Override
    public int hashCode() {
        int result = getComment() != null ? getComment().hashCode() : 0;
        result = 31 * result + (getAuditedTransaction() != null ? getAuditedTransaction().hashCode() : 0);
        result = 31 * result + (getIssuingActor() != null ? getIssuingActor().hashCode() : 0);
        result = 31 * result + (getName() != null ? getName().hashCode() : 0);
        result = 31 * result + (getValidationDate() != null ? getValidationDate().hashCode() : 0);
        result = 31 * result + (getValidatorOid() != null ? getValidatorOid().hashCode() : 0);
        result = 31 * result + (getAtnaQuestionnaire() != null ? getAtnaQuestionnaire().hashCode() : 0);
        result = 31 * result + (getProducedBySystem() != null ? getProducedBySystem().hashCode() : 0);
        return result;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean isEquivalent(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null || getClass() != obj.getClass()) {
            return false;
        }

        AuditedEvent that = (AuditedEvent) obj;

        if (getAuditedTransaction() != null ? !getAuditedTransaction().equals(that.getAuditedTransaction()) : that.getAuditedTransaction() != null) {
            return false;
        }
        if (getIssuingActor() != null ? !getIssuingActor().equals(that.getIssuingActor()) : that.getIssuingActor() != null) {
            return false;
        }
        if (getName() != null ? !getName().equals(that.getName()) : that.getName() != null) {
            return false;
        }
        if (getValidatorOid() != null ? !getValidatorOid().equals(that.getValidatorOid()) : that.getValidatorOid() != null) {
            return false;
        }

        return true;
    }

    public String getFileLocation() {
        return fileLocation;
    }

    /**
     * The file location must be relative to the audit-messages storage of the questionnaire base dir !
     *
     * @param fileLocation : path to file
     */
    public void setFileLocation(String fileLocation) {
        this.fileLocation = fileLocation;
    }

    public Date getValidationDate() {
        return validationDate != null ? (Date) validationDate.clone() : null;
    }

    public void setValidationDate(Date validationDate) {
        this.validationDate = validationDate != null ? (Date) validationDate.clone() : null;
    }

    public String getFileName() {
        if (this.fileLocation != null) {
            int begin = fileLocation.lastIndexOf(File.separatorChar);
            return fileLocation.substring(begin + 1);
        } else {
            return null;
        }
    }

    public String getValidationLogPath() {
        return validationLogPath;
    }

    public void setValidationLogPath(String validationLogPath) {
        this.validationLogPath = validationLogPath;
    }
}